import QtQuick 2.0
import CanvasPrinter 1.0

Rectangle
{
	id: topWindow
	width: 400
	height: 300

	property string message: "Click me."

	Canvas
	{
		id: canvas
		anchors.fill: parent
		renderStrategy: Canvas.Immediate

		onPaint: {
			var ctx = canvas.getContext('2d');
		
			ctx.save();
			ctx.fillStyle = Qt.rgba(1, 1, 1, 1);
			ctx.fillRect(0, 0, canvas.width, canvas.height);
			ctx.fill();
			ctx.restore();
		
			ctx.save();
			ctx.fillStyle = Qt.rgba(0, 0, 0, 1);
			ctx.font = '28px Ubuntu';
			ctx.textAlign = 'center';
			ctx.textBaseline = 'middle';
			ctx.fillText( topWindow.message, canvas.height/2, canvas.width/2 );
			ctx.fill();
			ctx.restore();
		}

        onAvailableChanged: {
            if (available) {
                var ctx = canvas.getContext('2d');
                var imageData = ctx.getImageData(0, 0, canvas.width, canvas.height);

                // Direct
                if (printer.setFromData(imageData.data, imageData.width, imageData.height)) {
                    if( printer.save('direct.png', "png", 100) )
                        print("Wrote 'direct.png'. ");
                    else
                        print("Failed 'direct.png'. ");
                } else {
                    print("setFromData failed (direct).");
                }

                // Indirect
                var copied = new Array();
                for( var x=0; x < imageData.data.length; x++ ) {
                    copied[x] = imageData.data[x];
                }
                print(x)

                if (printer.setFromData(copied, imageData.width, imageData.height)) {
                    if( printer.save('indirect.png', "png", 100) )
                        print("Wrote 'indirect.png'. ");
                    else
                        print("Failed 'indirect.png'. ");
                } else {
                    print("setFromData failed (indirect).");
                }

                Qt.quit();
            }
        }
	}

	CanvasPrinter
	{
		id: printer
	}
}

